#include <argos3/core/simulator/loop_functions.h>
#include <argos3/plugins/robots/foot-bot/simulator/footbot_entity.h>

using namespace argos;

class CDisasterLF : public CLoopFunctions {

public:

   CDisasterLF();
   virtual ~CDisasterLF();

   virtual void Init(TConfigurationNode& t_tree);
   virtual void Reset();
   virtual void Destroy();

   virtual void PreStep();
   virtual void PostStep();

   virtual bool IsExperimentFinished();

   virtual CColor GetFloorColor(const CVector2& c_position_on_plane);

protected:

   void CountVictimsFound();

protected:

   CVector2 m_cDeploymentAreaMinCorner;
   CVector2 m_cDeploymentAreaMaxCorner;
   std::vector<CFootBotEntity*> m_vecVictims;
   UInt32 m_unVictimsFound;
};
